diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/packetbb.cc ns-3.40/src/network/utils/packetbb.cc
--- ns-3.39/src/network/utils/packetbb.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/packetbb.cc	2023-09-27 13:30:37.858839800 -0700
@@ -23,9 +23,10 @@
 
 #include "packetbb.h"
 
+#include "ipv4-address.h"
+#include "ipv6-address.h"
+
 #include "ns3/assert.h"
-#include "ns3/ipv4-address.h"
-#include "ns3/ipv6-address.h"
 #include "ns3/log.h"
 
 static const uint8_t VERSION = 0;
@@ -181,7 +182,7 @@
 PbbTlvBlock::Clear()
 {
     NS_LOG_FUNCTION(this);
-    for (Iterator iter = Begin(); iter != End(); iter++)
+    for (auto iter = Begin(); iter != End(); iter++)
     {
         *iter = nullptr;
     }
@@ -194,7 +195,7 @@
     NS_LOG_FUNCTION(this);
     /* tlv size */
     uint32_t size = 2;
-    for (ConstIterator iter = Begin(); iter != End(); iter++)
+    for (auto iter = Begin(); iter != End(); iter++)
     {
         size += (*iter)->GetSerializedSize();
     }
@@ -215,7 +216,7 @@
      * position. */
     Buffer::Iterator tlvsize = start;
     start.Next(2);
-    for (ConstIterator iter = Begin(); iter != End(); iter++)
+    for (auto iter = Begin(); iter != End(); iter++)
     {
         (*iter)->Serialize(start);
     }
@@ -263,7 +264,7 @@
     os << prefix << "\tsize = " << Size() << std::endl;
     os << prefix << "\tmembers [" << std::endl;
 
-    for (ConstIterator iter = Begin(); iter != End(); iter++)
+    for (auto iter = Begin(); iter != End(); iter++)
     {
         (*iter)->Print(os, level + 2);
     }
@@ -420,7 +421,7 @@
 PbbAddressTlvBlock::Clear()
 {
     NS_LOG_FUNCTION(this);
-    for (Iterator iter = Begin(); iter != End(); iter++)
+    for (auto iter = Begin(); iter != End(); iter++)
     {
         *iter = nullptr;
     }
@@ -433,7 +434,7 @@
     NS_LOG_FUNCTION(this);
     /* tlv size */
     uint32_t size = 2;
-    for (ConstIterator iter = Begin(); iter != End(); iter++)
+    for (auto iter = Begin(); iter != End(); iter++)
     {
         size += (*iter)->GetSerializedSize();
     }
@@ -454,7 +455,7 @@
      * position. */
     Buffer::Iterator tlvsize = start;
     start.Next(2);
-    for (ConstIterator iter = Begin(); iter != End(); iter++)
+    for (auto iter = Begin(); iter != End(); iter++)
     {
         (*iter)->Serialize(start);
     }
@@ -502,7 +503,7 @@
     os << prefix << "\tsize = " << Size() << std::endl;
     os << prefix << "\tmembers [" << std::endl;
 
-    for (ConstIterator iter = Begin(); iter != End(); iter++)
+    for (auto iter = Begin(); iter != End(); iter++)
     {
         (*iter)->Print(os, level + 2);
     }
@@ -821,7 +822,7 @@
 PbbPacket::MessageClear()
 {
     NS_LOG_FUNCTION(this);
-    for (MessageIterator iter = MessageBegin(); iter != MessageEnd(); iter++)
+    for (auto iter = MessageBegin(); iter != MessageEnd(); iter++)
     {
         *iter = nullptr;
     }
@@ -861,7 +862,7 @@
         size += m_tlvList.GetSerializedSize();
     }
 
-    for (ConstMessageIterator iter = MessageBegin(); iter != MessageEnd(); iter++)
+    for (auto iter = MessageBegin(); iter != MessageEnd(); iter++)
     {
         size += (*iter)->GetSerializedSize();
     }
@@ -896,7 +897,7 @@
 
     bufref.WriteU8(flags);
 
-    for (ConstMessageIterator iter = MessageBegin(); iter != MessageEnd(); iter++)
+    for (auto iter = MessageBegin(); iter != MessageEnd(); iter++)
     {
         (*iter)->Serialize(start);
     }
@@ -951,7 +952,7 @@
 
     m_tlvList.Print(os, 1);
 
-    for (ConstMessageIterator iter = MessageBegin(); iter != MessageEnd(); iter++)
+    for (auto iter = MessageBegin(); iter != MessageEnd(); iter++)
     {
         (*iter)->Print(os, 1);
     }
@@ -1382,7 +1383,7 @@
 PbbMessage::AddressBlockClear()
 {
     NS_LOG_FUNCTION(this);
-    for (AddressBlockIterator iter = AddressBlockBegin(); iter != AddressBlockEnd(); iter++)
+    for (auto iter = AddressBlockBegin(); iter != AddressBlockEnd(); iter++)
     {
         *iter = nullptr;
     }
@@ -1418,7 +1419,7 @@
 
     size += m_tlvList.GetSerializedSize();
 
-    for (ConstAddressBlockIterator iter = AddressBlockBegin(); iter != AddressBlockEnd(); iter++)
+    for (auto iter = AddressBlockBegin(); iter != AddressBlockEnd(); iter++)
     {
         size += (*iter)->GetSerializedSize();
     }
@@ -1473,7 +1474,7 @@
 
     m_tlvList.Serialize(start);
 
-    for (ConstAddressBlockIterator iter = AddressBlockBegin(); iter != AddressBlockEnd(); iter++)
+    for (auto iter = AddressBlockBegin(); iter != AddressBlockEnd(); iter++)
     {
         (*iter)->Serialize(start);
     }
@@ -1601,7 +1602,7 @@
 
     m_tlvList.Print(os, level + 1);
 
-    for (ConstAddressBlockIterator iter = AddressBlockBegin(); iter != AddressBlockEnd(); iter++)
+    for (auto iter = AddressBlockBegin(); iter != AddressBlockEnd(); iter++)
     {
         (*iter)->Print(os, level + 1);
     }
@@ -1721,7 +1722,7 @@
 PbbMessageIpv4::SerializeOriginatorAddress(Buffer::Iterator& start) const
 {
     NS_LOG_FUNCTION(this << &start);
-    uint8_t* buffer = new uint8_t[GetAddressLength() + 1];
+    auto buffer = new uint8_t[GetAddressLength() + 1];
     Ipv4Address::ConvertFrom(GetOriginatorAddress()).Serialize(buffer);
     start.Write(buffer, GetAddressLength() + 1);
     delete[] buffer;
@@ -1731,7 +1732,7 @@
 PbbMessageIpv4::DeserializeOriginatorAddress(Buffer::Iterator& start) const
 {
     NS_LOG_FUNCTION(this << &start);
-    uint8_t* buffer = new uint8_t[GetAddressLength() + 1];
+    auto buffer = new uint8_t[GetAddressLength() + 1];
     start.Read(buffer, GetAddressLength() + 1);
     Address result = Ipv4Address::Deserialize(buffer);
     delete[] buffer;
@@ -1772,7 +1773,7 @@
 PbbMessageIpv6::SerializeOriginatorAddress(Buffer::Iterator& start) const
 {
     NS_LOG_FUNCTION(this << &start);
-    uint8_t* buffer = new uint8_t[GetAddressLength() + 1];
+    auto buffer = new uint8_t[GetAddressLength() + 1];
     Ipv6Address::ConvertFrom(GetOriginatorAddress()).Serialize(buffer);
     start.Write(buffer, GetAddressLength() + 1);
     delete[] buffer;
@@ -1782,7 +1783,7 @@
 PbbMessageIpv6::DeserializeOriginatorAddress(Buffer::Iterator& start) const
 {
     NS_LOG_FUNCTION(this << &start);
-    uint8_t* buffer = new uint8_t[GetAddressLength() + 1];
+    auto buffer = new uint8_t[GetAddressLength() + 1];
     start.Read(buffer, GetAddressLength() + 1);
     Address res = Ipv6Address::Deserialize(buffer);
     delete[] buffer;
@@ -2174,9 +2175,9 @@
     }
     else if (AddressSize() > 0)
     {
-        uint8_t* head = new uint8_t[GetAddressLength()];
+        auto head = new uint8_t[GetAddressLength()];
         uint8_t headlen = 0;
-        uint8_t* tail = new uint8_t[GetAddressLength()];
+        auto tail = new uint8_t[GetAddressLength()];
         uint8_t taillen = 0;
 
         GetHeadTail(head, headlen, tail, taillen);
@@ -2220,7 +2221,7 @@
 
     if (AddressSize() == 1)
     {
-        uint8_t* buf = new uint8_t[GetAddressLength()];
+        auto buf = new uint8_t[GetAddressLength()];
         SerializeAddress(buf, AddressBegin());
         start.Write(buf, GetAddressLength());
 
@@ -2234,8 +2235,8 @@
     }
     else if (AddressSize() > 0)
     {
-        uint8_t* head = new uint8_t[GetAddressLength()];
-        uint8_t* tail = new uint8_t[GetAddressLength()];
+        auto head = new uint8_t[GetAddressLength()];
+        auto tail = new uint8_t[GetAddressLength()];
         uint8_t headlen = 0;
         uint8_t taillen = 0;
 
@@ -2265,9 +2266,8 @@
 
         if (headlen + taillen < GetAddressLength())
         {
-            uint8_t* mid = new uint8_t[GetAddressLength()];
-            for (PbbAddressBlock::ConstAddressIterator iter = AddressBegin(); iter != AddressEnd();
-                 iter++)
+            auto mid = new uint8_t[GetAddressLength()];
+            for (auto iter = AddressBegin(); iter != AddressEnd(); iter++)
             {
                 SerializeAddress(mid, iter);
                 start.Write(mid + headlen, GetAddressLength() - headlen - taillen);
@@ -2278,7 +2278,7 @@
         flags |= GetPrefixFlags();
         bufref.WriteU8(flags);
 
-        for (ConstPrefixIterator iter = PrefixBegin(); iter != PrefixEnd(); iter++)
+        for (auto iter = PrefixBegin(); iter != PrefixEnd(); iter++)
         {
             start.WriteU8(*iter);
         }
@@ -2301,7 +2301,7 @@
     {
         uint8_t headlen = 0;
         uint8_t taillen = 0;
-        uint8_t* addrtmp = new uint8_t[GetAddressLength()];
+        auto addrtmp = new uint8_t[GetAddressLength()];
         memset(addrtmp, 0, GetAddressLength());
 
         if (flags & AHAS_HEAD)
@@ -2363,7 +2363,7 @@
 
     os << prefix << "PbbAddressBlock {" << std::endl;
     os << prefix << "\taddresses = " << std::endl;
-    for (ConstAddressIterator iter = AddressBegin(); iter != AddressEnd(); iter++)
+    for (auto iter = AddressBegin(); iter != AddressEnd(); iter++)
     {
         os << prefix << "\t\t";
         PrintAddress(os, iter);
@@ -2371,7 +2371,7 @@
     }
 
     os << prefix << "\tprefixes = " << std::endl;
-    for (ConstPrefixIterator iter = PrefixBegin(); iter != PrefixEnd(); iter++)
+    for (auto iter = PrefixBegin(); iter != PrefixEnd(); iter++)
     {
         os << prefix << "\t\t" << (int)(*iter) << std::endl;
     }
@@ -2452,15 +2452,14 @@
     taillen = headlen;
 
     /* Temporary automatic buffers to store serialized addresses */
-    uint8_t* buflast = new uint8_t[GetAddressLength()];
-    uint8_t* bufcur = new uint8_t[GetAddressLength()];
+    auto buflast = new uint8_t[GetAddressLength()];
+    auto bufcur = new uint8_t[GetAddressLength()];
     uint8_t* tmp;
 
     SerializeAddress(buflast, AddressBegin());
 
     /* Skip the first item */
-    for (PbbAddressBlock::ConstAddressIterator iter = AddressBegin()++; iter != AddressEnd();
-         iter++)
+    for (auto iter = AddressBegin()++; iter != AddressEnd(); iter++)
     {
         SerializeAddress(bufcur, iter);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/packet-burst.cc ns-3.40/src/network/utils/packet-burst.cc
--- ns-3.39/src/network/utils/packet-burst.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/packet-burst.cc	2023-09-27 13:30:37.858839800 -0700
@@ -50,8 +50,7 @@
 PacketBurst::~PacketBurst()
 {
     NS_LOG_FUNCTION(this);
-    for (std::list<Ptr<Packet>>::const_iterator iter = m_packets.begin(); iter != m_packets.end();
-         ++iter)
+    for (auto iter = m_packets.begin(); iter != m_packets.end(); ++iter)
     {
         (*iter)->Unref();
     }
@@ -70,8 +69,7 @@
     NS_LOG_FUNCTION(this);
     Ptr<PacketBurst> burst = Create<PacketBurst>();
 
-    for (std::list<Ptr<Packet>>::const_iterator iter = m_packets.begin(); iter != m_packets.end();
-         ++iter)
+    for (auto iter = m_packets.begin(); iter != m_packets.end(); ++iter)
     {
         Ptr<Packet> packet = (*iter)->Copy();
         burst->AddPacket(packet);
@@ -108,8 +106,7 @@
 {
     NS_LOG_FUNCTION(this);
     uint32_t size = 0;
-    for (std::list<Ptr<Packet>>::const_iterator iter = m_packets.begin(); iter != m_packets.end();
-         ++iter)
+    for (auto iter = m_packets.begin(); iter != m_packets.end(); ++iter)
     {
         Ptr<Packet> packet = *iter;
         size += packet->GetSize();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/packet-data-calculators.cc ns-3.40/src/network/utils/packet-data-calculators.cc
--- ns-3.39/src/network/utils/packet-data-calculators.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/packet-data-calculators.cc	2023-09-27 13:30:37.858839800 -0700
@@ -19,9 +19,10 @@
 
 #include "packet-data-calculators.h"
 
+#include "mac48-address.h"
+
 #include "ns3/basic-data-calculators.h"
 #include "ns3/log.h"
-#include "ns3/mac48-address.h"
 #include "ns3/packet.h"
 
 using namespace ns3;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/packet-data-calculators.h ns-3.40/src/network/utils/packet-data-calculators.h
--- ns-3.39/src/network/utils/packet-data-calculators.h	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/packet-data-calculators.h	2023-09-27 13:30:37.858839800 -0700
@@ -20,9 +20,10 @@
 #ifndef PACKET_DATA_CALCULATORS_H
 #define PACKET_DATA_CALCULATORS_H
 
+#include "mac48-address.h"
+
 #include "ns3/basic-data-calculators.h"
 #include "ns3/data-calculator.h"
-#include "ns3/mac48-address.h"
 #include "ns3/packet.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/packet-probe.cc ns-3.40/src/network/utils/packet-probe.cc
--- ns-3.39/src/network/utils/packet-probe.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/packet-probe.cc	2023-09-27 13:30:37.858839800 -0700
@@ -20,7 +20,7 @@
  * Modified by: Mitch Watrous (watrous@u.washington.edu)
  */
 
-#include "ns3/packet-probe.h"
+#include "packet-probe.h"
 
 #include "ns3/config.h"
 #include "ns3/log.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/packet-socket.cc ns-3.40/src/network/utils/packet-socket.cc
--- ns-3.39/src/network/utils/packet-socket.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/packet-socket.cc	2023-09-27 13:30:37.858839800 -0700
@@ -659,7 +659,7 @@
 DeviceNameTag::Serialize(TagBuffer i) const
 {
     const char* n = m_deviceName.c_str();
-    uint8_t l = (uint8_t)m_deviceName.size();
+    auto l = (uint8_t)m_deviceName.size();
 
     i.WriteU8(l);
     i.Write((uint8_t*)n, (uint32_t)l);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/packet-socket-client.cc ns-3.40/src/network/utils/packet-socket-client.cc
--- ns-3.39/src/network/utils/packet-socket-client.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/packet-socket-client.cc	2023-09-27 13:30:37.858839800 -0700
@@ -19,12 +19,13 @@
 
 #include "packet-socket-client.h"
 
+#include "packet-socket-address.h"
+#include "packet-socket-factory.h"
+#include "packet-socket.h"
+
 #include "ns3/abort.h"
 #include "ns3/log.h"
 #include "ns3/nstime.h"
-#include "ns3/packet-socket-address.h"
-#include "ns3/packet-socket-factory.h"
-#include "ns3/packet-socket.h"
 #include "ns3/packet.h"
 #include "ns3/simulator.h"
 #include "ns3/socket-factory.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/packet-socket-client.h ns-3.40/src/network/utils/packet-socket-client.h
--- ns-3.39/src/network/utils/packet-socket-client.h	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/packet-socket-client.h	2023-09-27 13:30:37.858839800 -0700
@@ -20,9 +20,10 @@
 #ifndef PACKET_SOCKET_CLIENT_H
 #define PACKET_SOCKET_CLIENT_H
 
+#include "packet-socket-address.h"
+
 #include "ns3/application.h"
 #include "ns3/event-id.h"
-#include "ns3/packet-socket-address.h"
 #include "ns3/ptr.h"
 #include "ns3/traced-callback.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/packet-socket-server.cc ns-3.40/src/network/utils/packet-socket-server.cc
--- ns-3.39/src/network/utils/packet-socket-server.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/packet-socket-server.cc	2023-09-27 13:30:37.858839800 -0700
@@ -19,12 +19,13 @@
 
 #include "packet-socket-server.h"
 
+#include "packet-socket-address.h"
+#include "packet-socket-factory.h"
+#include "packet-socket.h"
+
 #include "ns3/abort.h"
 #include "ns3/log.h"
 #include "ns3/nstime.h"
-#include "ns3/packet-socket-address.h"
-#include "ns3/packet-socket-factory.h"
-#include "ns3/packet-socket.h"
 #include "ns3/packet.h"
 #include "ns3/simulator.h"
 #include "ns3/socket-factory.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/packet-socket-server.h ns-3.40/src/network/utils/packet-socket-server.h
--- ns-3.39/src/network/utils/packet-socket-server.h	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/packet-socket-server.h	2023-09-27 13:30:37.858839800 -0700
@@ -20,9 +20,10 @@
 #ifndef PACKET_SOCKET_SERVER_H
 #define PACKET_SOCKET_SERVER_H
 
+#include "packet-socket-address.h"
+
 #include "ns3/application.h"
 #include "ns3/event-id.h"
-#include "ns3/packet-socket-address.h"
 #include "ns3/ptr.h"
 #include "ns3/traced-callback.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/pcap-file.cc ns-3.40/src/network/utils/pcap-file.cc
--- ns-3.39/src/network/utils/pcap-file.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/pcap-file.cc	2023-09-27 13:30:37.858839800 -0700
@@ -404,7 +404,7 @@
     //
     // And set swap mode if requested or we are on a big-endian system.
     //
-    m_swapMode = swapMode | bigEndian;
+    m_swapMode = swapMode || bigEndian;
 
     WriteFileHeader();
 }
@@ -552,8 +552,8 @@
         return true;
     }
 
-    uint8_t* data1 = new uint8_t[snapLen]();
-    uint8_t* data2 = new uint8_t[snapLen]();
+    auto data1 = new uint8_t[snapLen]();
+    auto data2 = new uint8_t[snapLen]();
     uint32_t tsSec1 = 0;
     uint32_t tsSec2 = 0;
     uint32_t tsUsec1 = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/queue.h ns-3.40/src/network/utils/queue.h
--- ns-3.39/src/network/utils/queue.h	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/queue.h	2023-09-27 13:30:37.858839800 -0700
@@ -22,12 +22,13 @@
 #ifndef QUEUE_H
 #define QUEUE_H
 
+#include "queue-fwd.h"
+#include "queue-item.h"
+#include "queue-size.h"
+
 #include "ns3/log.h"
 #include "ns3/object.h"
 #include "ns3/packet.h"
-#include "ns3/queue-fwd.h"
-#include "ns3/queue-item.h"
-#include "ns3/queue-size.h"
 #include "ns3/traced-callback.h"
 #include "ns3/traced-value.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/simple-channel.cc ns-3.40/src/network/utils/simple-channel.cc
--- ns-3.39/src/network/utils/simple-channel.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/simple-channel.cc	2023-09-27 13:30:37.858839800 -0700
@@ -62,9 +62,7 @@
                     Ptr<SimpleNetDevice> sender)
 {
     NS_LOG_FUNCTION(this << p << protocol << to << from << sender);
-    for (std::vector<Ptr<SimpleNetDevice>>::const_iterator i = m_devices.begin();
-         i != m_devices.end();
-         ++i)
+    for (auto i = m_devices.begin(); i != m_devices.end(); ++i)
     {
         Ptr<SimpleNetDevice> tmp = *i;
         if (tmp == sender)
@@ -133,8 +131,7 @@
 {
     if (m_blackListedDevices.find(to) != m_blackListedDevices.end())
     {
-        std::vector<Ptr<SimpleNetDevice>>::iterator iter;
-        iter = find(m_blackListedDevices[to].begin(), m_blackListedDevices[to].end(), from);
+        auto iter = find(m_blackListedDevices[to].begin(), m_blackListedDevices[to].end(), from);
         if (iter != m_blackListedDevices[to].end())
         {
             m_blackListedDevices[to].erase(iter);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/simple-net-device.cc ns-3.40/src/network/utils/simple-net-device.cc
--- ns-3.39/src/network/utils/simple-net-device.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/simple-net-device.cc	2023-09-27 13:30:37.858839800 -0700
@@ -18,15 +18,15 @@
  */
 #include "simple-net-device.h"
 
+#include "error-model.h"
+#include "queue.h"
 #include "simple-channel.h"
 
 #include "ns3/boolean.h"
-#include "ns3/error-model.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/packet.h"
 #include "ns3/pointer.h"
-#include "ns3/queue.h"
 #include "ns3/simulator.h"
 #include "ns3/string.h"
 #include "ns3/tag.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/utils/simple-net-device.h ns-3.40/src/network/utils/simple-net-device.h
--- ns-3.39/src/network/utils/simple-net-device.h	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/network/utils/simple-net-device.h	2023-09-27 13:30:37.858839800 -0700
@@ -19,12 +19,12 @@
 #ifndef SIMPLE_NET_DEVICE_H
 #define SIMPLE_NET_DEVICE_H
 
+#include "data-rate.h"
 #include "mac48-address.h"
+#include "queue-fwd.h"
 
-#include "ns3/data-rate.h"
 #include "ns3/event-id.h"
 #include "ns3/net-device.h"
-#include "ns3/queue-fwd.h"
 #include "ns3/traced-callback.h"
 
 #include <stdint.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/nix-vector-routing/examples/nms-p2p-nix.cc ns-3.40/src/nix-vector-routing/examples/nms-p2p-nix.cc
--- ns-3.39/src/nix-vector-routing/examples/nms-p2p-nix.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/nix-vector-routing/examples/nms-p2p-nix.cc	2023-09-27 13:30:37.858839800 -0700
@@ -193,7 +193,7 @@
 
     Array2D<NodeContainer> nodes_net0(nCN, 3);
     Array2D<NodeContainer> nodes_net1(nCN, 6);
-    NodeContainer* nodes_netLR = new NodeContainer[nCN];
+    auto nodes_netLR = new NodeContainer[nCN];
     Array2D<NodeContainer> nodes_net2(nCN, 14);
     Array3D<NodeContainer> nodes_net2LAN(nCN, 7, nLANClients);
     Array2D<NodeContainer> nodes_net3(nCN, 9);
@@ -599,7 +599,7 @@
     if (nCN > 1)
     {
         std::cout << "Forming Ring Topology..." << std::endl;
-        NodeContainer* nodes_ring = new NodeContainer[nCN];
+        auto nodes_ring = new NodeContainer[nCN];
         for (int z = 0; z < nCN - 1; ++z)
         {
             nodes_ring[z].Add(nodes_net0[z][0].Get(0));
@@ -607,7 +607,7 @@
         }
         nodes_ring[nCN - 1].Add(nodes_net0[nCN - 1][0].Get(0));
         nodes_ring[nCN - 1].Add(nodes_net0[0][0].Get(0));
-        NetDeviceContainer* ndc_ring = new NetDeviceContainer[nCN];
+        auto ndc_ring = new NetDeviceContainer[nCN];
         for (int z = 0; z < nCN; ++z)
         {
             ndc_ring[z] = p2p_2gb200ms.Install(nodes_ring[z]);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/nix-vector-routing/model/nix-vector-routing.cc ns-3.40/src/nix-vector-routing/model/nix-vector-routing.cc
--- ns-3.39/src/nix-vector-routing/model/nix-vector-routing.cc	2023-07-05 14:23:48.065428300 -0700
+++ ns-3.40/src/nix-vector-routing/model/nix-vector-routing.cc	2023-09-27 13:30:37.858839800 -0700
@@ -151,8 +151,7 @@
 {
     NS_LOG_FUNCTION_NOARGS();
 
-    NodeList::Iterator listEnd = NodeList::End();
-    for (NodeList::Iterator i = NodeList::Begin(); i != listEnd; i++)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
     {
         Ptr<Node> node = *i;
         Ptr<NixVectorRouting<T>> rp = node->GetObject<NixVectorRouting>();
@@ -248,7 +247,7 @@
 
     CheckCacheStateAndFlush();
 
-    typename NixMap_t::iterator iter = m_nixCache.find(address);
+    auto iter = m_nixCache.find(address);
     if (iter != m_nixCache.end())
     {
         NS_LOG_LOGIC("Found Nix-vector in cache.");
@@ -269,7 +268,7 @@
 
     CheckCacheStateAndFlush();
 
-    typename IpRouteMap_t::iterator iter = m_ipRouteCache.find(address);
+    auto iter = m_ipRouteCache.find(address);
     if (iter != m_ipRouteCache.end())
     {
         NS_LOG_LOGIC("Found IpRoute in cache.");
@@ -334,9 +333,7 @@
         // the index  to the nix vector.
         // the index corresponds to the neighbor index
         uint32_t offset = 0;
-        for (NetDeviceContainer::Iterator iter = netDeviceContainer.Begin();
-             iter != netDeviceContainer.End();
-             iter++)
+        for (auto iter = netDeviceContainer.Begin(); iter != netDeviceContainer.End(); iter++)
         {
             Ptr<Node> remoteNode = (*iter)->GetNode();
 
@@ -466,7 +463,7 @@
 {
     NS_LOG_FUNCTION_NOARGS();
 
-    for (NodeList::Iterator it = NodeList::Begin(); it != NodeList::End(); ++it)
+    for (auto it = NodeList::Begin(); it != NodeList::End(); ++it)
     {
         Ptr<Node> node = *it;
         Ptr<IpL3Protocol> ip = node->GetObject<IpL3Protocol>();
@@ -528,7 +525,7 @@
 
     Ptr<Node> destNode;
 
-    typename IpAddressToNodeMap::iterator iter = g_ipAddressToNodeMap.find(dest);
+    auto iter = g_ipAddressToNodeMap.find(dest);
 
     if (iter == g_ipAddressToNodeMap.end())
     {
@@ -555,7 +552,7 @@
 
     Ptr<IpInterface> ipInterface;
 
-    typename NetDeviceToIpInterfaceMap::iterator iter = g_netdeviceToIpInterfaceMap.find(netDevice);
+    auto iter = g_netdeviceToIpInterfaceMap.find(netDevice);
 
     if (iter == g_netdeviceToIpInterfaceMap.end())
     {
@@ -1021,8 +1018,7 @@
     {
         *os << std::setw(30) << "Destination";
         *os << "NixVector" << std::endl;
-        for (typename NixMap_t::const_iterator it = m_nixCache.begin(); it != m_nixCache.end();
-             it++)
+        for (auto it = m_nixCache.begin(); it != m_nixCache.end(); it++)
         {
             std::ostringstream dest;
             dest << it->first;
@@ -1045,9 +1041,7 @@
         *os << std::setw(30) << "Gateway";
         *os << std::setw(30) << "Source";
         *os << "OutputDevice" << std::endl;
-        for (typename IpRouteMap_t::const_iterator it = m_ipRouteCache.begin();
-             it != m_ipRouteCache.end();
-             it++)
+        for (auto it = m_ipRouteCache.begin(); it != m_ipRouteCache.end(); it++)
         {
             std::ostringstream dest;
             std::ostringstream gw;
@@ -1193,9 +1187,7 @@
             // and scan through them.  We push them
             // to the greyNode queue, if they aren't
             // already there.
-            for (NetDeviceContainer::Iterator iter = netDeviceContainer.Begin();
-                 iter != netDeviceContainer.End();
-                 iter++)
+            for (auto iter = netDeviceContainer.Begin(); iter != netDeviceContainer.End(); iter++)
             {
                 Ptr<Node> remoteNode = (*iter)->GetNode();
                 Ptr<IpInterface> remoteIpInterface = GetInterfaceByNetDevice(*iter);
@@ -1257,8 +1249,7 @@
                 // and scan through them.  We push them
                 // to the greyNode queue, if they aren't
                 // already there.
-                for (NetDeviceContainer::Iterator iter = netDeviceContainer.Begin();
-                     iter != netDeviceContainer.End();
+                for (auto iter = netDeviceContainer.Begin(); iter != netDeviceContainer.End();
                      iter++)
                 {
                     Ptr<Node> remoteNode = (*iter)->GetNode();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/olsr/examples/olsr-hna.cc ns-3.40/src/olsr/examples/olsr-hna.cc
--- ns-3.39/src/olsr/examples/olsr-hna.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/olsr/examples/olsr-hna.cc	2023-09-27 13:30:37.858839800 -0700
@@ -41,12 +41,12 @@
 // One way is to use olsr::RoutingProtocol::SetRoutingTableAssociation ()
 // to use which you may run:
 //
-// ./ns3 run "olsr-hna --assocMethod1=1"
+// ./ns3 run "olsr-hna --assocMethod=SetRoutingTable"
 //
 // The other way is to use olsr::RoutingProtocol::AddHostNetworkAssociation ()
 // to use which you may run:
 //
-// ./ns3 run "olsr-hna --assocMethod2=1"
+// ./ns3 run "olsr-hna --assocMethod=AddHostNetwork"
 //
 
 #include "ns3/config-store-module.h"
@@ -102,8 +102,8 @@
     uint32_t numPackets = 1;
     double interval = 1.0; // seconds
     bool verbose = false;
-    bool assocMethod1 = false;
-    bool assocMethod2 = false;
+    std::string assocMethod("SetRoutingTable");
+    bool reverse = false;
 
     CommandLine cmd(__FILE__);
 
@@ -113,8 +113,11 @@
     cmd.AddValue("numPackets", "number of packets generated", numPackets);
     cmd.AddValue("interval", "interval (seconds) between packets", interval);
     cmd.AddValue("verbose", "turn on all WifiNetDevice log components", verbose);
-    cmd.AddValue("assocMethod1", "Use SetRoutingTableAssociation () method", assocMethod1);
-    cmd.AddValue("assocMethod2", "Use AddHostNetworkAssociation () method", assocMethod2);
+    cmd.AddValue("assocMethod",
+                 "How to add the host to the HNA table (SetRoutingTable, "
+                 "AddHostNetwork)",
+                 assocMethod);
+    cmd.AddValue("reverse", "Send packets from CSMA to WiFi if set to true", reverse);
 
     cmd.Parse(argc, argv);
     // Convert to time object
@@ -210,34 +213,39 @@
     ipv4.Assign(csmaDevices);
 
     TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
-    Ptr<Socket> recvSink = Socket::CreateSocket(csmaNodes.Get(0), tid);
+    Ptr<Socket> recvSink;
+    if (!reverse)
+    {
+        recvSink = Socket::CreateSocket(csmaNodes.Get(0), tid);
+    }
+    else
+    {
+        recvSink = Socket::CreateSocket(olsrNodes.Get(0), tid);
+    }
     InetSocketAddress local = InetSocketAddress(Ipv4Address::GetAny(), 80);
     recvSink->Bind(local);
     recvSink->SetRecvCallback(MakeCallback(&ReceivePacket));
 
-    Ptr<Socket> source = Socket::CreateSocket(olsrNodes.Get(0), tid);
-    InetSocketAddress remote = InetSocketAddress(Ipv4Address("172.16.1.1"), 80);
-    source->Connect(remote);
+    Ptr<Socket> source;
+    if (!reverse)
+    {
+        source = Socket::CreateSocket(olsrNodes.Get(0), tid);
+        InetSocketAddress remote = InetSocketAddress(Ipv4Address("172.16.1.1"), 80);
+        source->Connect(remote);
+    }
+    else
+    {
+        source = Socket::CreateSocket(csmaNodes.Get(0), tid);
+        InetSocketAddress remote = InetSocketAddress(Ipv4Address("10.1.1.1"), 80);
+        source->Connect(remote);
+    }
 
     // Obtain olsr::RoutingProtocol instance of gateway node
     // (namely, node B) and add the required association
-    Ptr<Ipv4> stack = olsrNodes.Get(1)->GetObject<Ipv4>();
-    Ptr<Ipv4RoutingProtocol> rp_Gw = (stack->GetRoutingProtocol());
-    Ptr<Ipv4ListRouting> lrp_Gw = DynamicCast<Ipv4ListRouting>(rp_Gw);
+    Ptr<olsr::RoutingProtocol> olsrrp_Gw = Ipv4RoutingHelper::GetRouting<olsr::RoutingProtocol>(
+        olsrNodes.Get(1)->GetObject<Ipv4>()->GetRoutingProtocol());
 
-    Ptr<olsr::RoutingProtocol> olsrrp_Gw;
-
-    for (uint32_t i = 0; i < lrp_Gw->GetNRoutingProtocols(); i++)
-    {
-        int16_t priority;
-        Ptr<Ipv4RoutingProtocol> temp = lrp_Gw->GetRoutingProtocol(i, priority);
-        if (DynamicCast<olsr::RoutingProtocol>(temp))
-        {
-            olsrrp_Gw = DynamicCast<olsr::RoutingProtocol>(temp);
-        }
-    }
-
-    if (assocMethod1)
+    if (assocMethod == "SetRoutingTable")
     {
         // Create a special Ipv4StaticRouting instance for RoutingTableAssociation
         // Even the Ipv4StaticRouting instance added to list may be used
@@ -252,16 +260,26 @@
                                       uint32_t(1));
         olsrrp_Gw->SetRoutingTableAssociation(hnaEntries);
     }
-
-    if (assocMethod2)
+    else if (assocMethod == "AddHostNetwork")
     {
         // Specify the required associations directly.
         olsrrp_Gw->AddHostNetworkAssociation(Ipv4Address("172.16.1.0"), Ipv4Mask("255.255.255.0"));
     }
+    else
+    {
+        std::cout << "invalid HnaMethod option (" << assocMethod << ")" << std::endl;
+        exit(0);
+    }
+
+    // Add a default route to the CSMA node (to enable replies)
+    Ptr<Ipv4StaticRouting> staticRoutingProt;
+    staticRoutingProt = Ipv4RoutingHelper::GetRouting<Ipv4StaticRouting>(
+        csmaNodes.Get(0)->GetObject<Ipv4>()->GetRoutingProtocol());
+    staticRoutingProt->AddNetworkRouteTo("10.1.1.0", "255.255.255.0", "172.16.1.2", 1);
 
     // Tracing
-    wifiPhy.EnablePcap("olsr-hna", devices);
-    csma.EnablePcap("olsr-hna", csmaDevices, false);
+    wifiPhy.EnablePcap("olsr-hna-wifi", devices);
+    csma.EnablePcap("olsr-hna-csma", csmaDevices, false);
     AsciiTraceHelper ascii;
     wifiPhy.EnableAsciiAll(ascii.CreateFileStream("olsr-hna-wifi.tr"));
     csma.EnableAsciiAll(ascii.CreateFileStream("olsr-hna-csma.tr"));
@@ -274,6 +292,10 @@
                                    numPackets,
                                    interPacketInterval);
 
+    Ptr<OutputStreamWrapper> routingStream =
+        Create<OutputStreamWrapper>("olsr-hna.routes", std::ios::out);
+    Ipv4RoutingHelper::PrintRoutingTableAllAt(Seconds(15), routingStream);
+
     Simulator::Stop(Seconds(20.0));
     Simulator::Run();
     Simulator::Destroy();
